// CS7b-S14
// Inheritance and Polymorphism with Brass and BrassPlus
// polymorphism example

#include <iostream>
#include "brass.h"
#include <string>
//#define CLIENTS 4
const int CLIENTS = 4;

/* The user inputs the type of account to be added and then
uses new to create and initialize an object of the proper type.
 getline(cin,temp) reads a line of input from cin and stores it in the string
 object temp

If the array member points to a Brass object, Brass::ViewAcct() is
invoked; if the array member points to a BrassPlus object,
BrassPlus::ViewAcct() is invoked.  This where the "virtual" feature
is critical.

We use "delete" to free the objects allocated by "new".
This illustrates why the base class should have a virtual destructor,
even if no destructor appears to be needed.  If the destructs
are not virtual, then just the destructor corresponding to the
pointer type is called.  This means that only the Brass destructor is called,
even if the point points to a BrassPlus object.  If the destructor are virtual
the destuct correspoding to the object to the object type is called.

And wehen a BrassPlus destructor finishes, it automatically calls the base-class
constructor, thus, using virtual destructors ensures that the correct
sequence of destructors is called. This isn't essential here, because
the destructors do nothing.  So if BrassPlus had a "do something"
destructor, it would be vital for Brass' destructor to be virtual.

A reeference or a pointer to a base class can refer to a derived class object
without using an explicit type cast.  Converting a derived-class reference
or pointer to a base-class reference or pointer is called "upcasting."
and is always allowed for public inferitance without the need for an explicit tuype
cast.  Upcasting is transitive.

Downcasting is not allowed without an explicit type cast.
*/
using namespace std;

void fr(Brass & rb); //uses rb.ViewAcct()
void fp(Brass * pb);  // uses pb->ViewAcct()
void fv(Brass b);  // uses b.ViewAcct()

int main()
{
    Brass b("billy Bee", 1234123, 1000.00);
    BrassPlus bp("Betty Beep", 2332332, 12345.00);
    fr(b); cout << endl;
    fr(bp); cout << endl;
    fp(&b); cout << endl;
    fp(&bp); cout << endl;
    fv(b); cout << endl;
    fv(bp); cout << endl;

    BrassPlus Ophelia; //derived class object
    Brass * bO;  // base-class pointer
    bO = &Ophelia;  // Brass pointer to BrassPlus object
    bO->ViewAcct();  // which version?

    return 0;
}

void fr(Brass & rb) {
    rb.ViewAcct();
} //uses rb.ViewAcct()

void fp(Brass * pb) {
    pb->ViewAcct();
}  // uses pb->ViewAcct()

void fv(Brass b) {
    b.ViewAcct();
}  // uses b.ViewAcct()
